Loading...
Searching...
No Matches
casacore::VanVleck Class Reference
scimath package (libcasa_scimath) » Mathematics_module

More...

`#include <VanVleck.h>`

## Static Public Member Functions

static void | size (uInt npts)
| Set the interpolation table size.
static uInt | getsize ()
| get the current size.
static void | setQuantization (const Matrix< Double > &qx, const Matrix< Double > &qy)
| Set the x and y quantization functions.
static Bool | setEquiSpaced (Double xlev, Double ylev, Double xmean, Double ymean, Int n)
| Set the x and y quantization levels for the case of equi-spaced levels with a possible non-zero offset.
static void | getTable (Vector< Double > &rs, Vector< Double > &rhos)
| Get the data used in setting up the interpolation.
static Double | r (const Double rho)
| Given a rho return the corresponding corrected r Returns 0.0 if no quantization has been set yet.
static Double | thresh (Int n, Double zerolag)
| Given a measured zero-lag autocorrelation and number of levels (n>=3) return the first positive quantizer input threshold level.
static Double | predict (Int n, Double threshhold)
| Predict a given zero-lag given n and a threshold.
static Bool | dcoff (Double &dcoffset, Double &threshold, Int n, Double zerolag, Double bias)
| Compute an approximation to the mean signal level (DC offset) and quantizer threshold setting (both in terms of the r.m.s.

## Static Private Member Functions

static Double | drbydrho (Double *rho)
| The fortran numerical integration function will call this.
static Double | rinc (Double &rhoi, Double &rhof)
| For a given rhoi, rhof, this produces a high-accuracy numerical approximation to the integral of drbydrho over the range rhoi to rhof.
static void | initInterpolator ()
| initialize the interpolator
static Double | threshNgt3 (Int n, Double zerolag)
| compute first threshhold for a given zerolag for n>3
static Double | threshN3 (Double zerolag)
| compute first threshhold for a given zerolag for n==3
static Double | invErf (Double x)
| inverse err fn - used by invErfc
static Double | invErfc (Double x)
| inverse complementary err fn - used by threshN3
static Double | predictNgt3 (Int n, Double threshhold)
| Predict a zero-lag value given the indicated first threshold level for n>3.
static Double | predictN3 (Double threshhold)
| Predict a zero-lag value given the indicated first threshold level for n=3.
static Bool | dcoff3 (Double &dcoffset, Double &threshold, Double zerolag, Double bias)
| implementation of dcoff for the 3-level case

## Static Private Attributes

static uInt | itsSize
| the number of points to use in setting up the interpolator
static uInt | itsNx
static uInt | itsNy
static Bool | itsEquiSpaced
static Double | itsXlev
static Double | itsYlev
static Double | itsXmean
static Double | itsYmean
static Interpolate1D< Double, Double > * | itsInterp
| The interpolator.
static Vector< Double > | itsQx0
| the quantization functions
static Vector< Double > | itsQx1
static Vector< Double > | itsQy0
static Vector< Double > | itsQy1
static Vector< Double > | itsQx0Qx0
| Useful combinations of the above - to speed up drbydrho these are -1/2*(Qx0*Qx0) and -1/2*(Qy0*Qy0) These are only used for i up to (itsQx0.nelements() and for j up to (itsQy0.nelements()).
static Vector< Double > | itsQy0Qy0
static Matrix< Double > | itsQx0Qy0
| This is Qx0[i]*Qy0[j].
static Matrix< Double > | itsQx1Qy1diffs
| This is (Qx1[i+1]-Qx1[i])*(Qy1[j+1]*Qy1[j]).
static std::mutex | theirMutex
| The mutex to make the functions thread-safe.

## Detailed Description

A class of static functions to aid with vanVleck corrections of lag data.

### Intended use:

Public interface

### Review Status

Date Reviewed:
  yyyy/mm/dd

### Prerequisite

- Familiarity with the issues involved in turning digitally sampled lag data from a correlator into spectral data.

### Etymology

This provides the functions necessary to determine the van Vleck correction for a general n-level by m-level correlator.

### Synopsis

This provides the functions necessary to determine the van Vleck correction for a general n-level by m-level correlator.

### Example

### Motivation

The GBT spectrometer provides the measured auto-correlation and cross-correlation lags. The gbt MeasurementSet filler (gbtmsfiller) needs to convert those lags to the spectral domain. These functions allow the filler to calculate the van Vleck correction appropriate for each measured set of lags. They are of general and hence are not specific to the GBT spectrometer.

The functions here are static because of the nature of the underlying numerical quadrature fortran code used to integrate the drbyrho function.

### Thrown Exceptions

### To Do

- The inverse error functions may be more generally useful. It exists here only as a private member function to be used internally.

Definition at line 92 of file VanVleck.h.

## Member Function Documentation

## dcoff()

Bool casacore::VanVleck::dcoff | ( | Double & | dcoffset,
|  | Double & | threshold,
|  | Int | n,
|  | Double | zerolag,
|  | Double | bias )

static

Compute an approximation to the mean signal level (DC offset) and quantizer threshold setting (both in terms of the r.m.s.

signal input level) given the observed positive bias (the asymptotic limit of the measured autocorrelation at large lags) and the zero-lag autocorrelation. dcoffset is the mean signal level, threshold is the quantizer setting, n is the number of levels, zerolag is the zero-lag value and bias is the asymptotic bias. Currently, this is only available for the n==3 level case, all other cases set the returned dcoffset to 0 and use thresh() to set the returned value of threshold. A return value of F indicates that the zerolag and bias values are inconsistent and the dcoffset can not be determined. In that case, the returned dcoffset is 0 and thresh() is used to set the threshold level.

## dcoff3()

Bool casacore::VanVleck::dcoff3 | ( | Double & | dcoffset,
|  | Double & | threshold,
|  | Double | zerolag,
|  | Double | bias )

static private

implementation of dcoff for the 3-level case

## drbydrho()

Double casacore::VanVleck::drbydrho | ( | Double * | rho | ) |

static private

The fortran numerical integration function will call this.

For a given rho and quantization functions, this computes, via Price's theorem, the value dr/drho of the derivative, with respect to rho, of the expected value of the correlator output.

## getsize()

uInt casacore::VanVleck::getsize | ( |  | ) |

static

get the current size.

## getTable()

void casacore::VanVleck::getTable | ( | Vector< Double > & | rs,
|  | Vector< Double > & | rhos )

static

Get the data used in setting up the interpolation.

## initInterpolator()

void casacore::VanVleck::initInterpolator | ( |  | ) |

static private

initialize the interpolator

## invErf()

Double casacore::VanVleck::invErf | ( | Double | x | ) |

static private

inverse err fn - used by invErfc

## invErfc()

Double casacore::VanVleck::invErfc | ( | Double | x | ) |

static private

inverse complementary err fn - used by threshN3

Referenced by threshN3().

## predict()

Double casacore::VanVleck::predict | ( | Int | n,
|  | Double | threshhold )

inline static

Predict a given zero-lag given n and a threshold.

This is included here to be used as a check against the output of thresh.

Definition at line 143 of file VanVleck.h.

References predictN3(), and predictNgt3().

## predictN3()

Double casacore::VanVleck::predictN3 | ( | Double | threshhold | ) |

inline static private

Predict a zero-lag value given the indicated first threshold level for n=3.

Definition at line 227 of file VanVleck.h.

References casacore::sqrt().

Referenced by predict().

## predictNgt3()

Double casacore::VanVleck::predictNgt3 | ( | Int | n,
|  | Double | threshhold )

static private

Predict a zero-lag value given the indicated first threshold level for n>3.

Referenced by predict().

## r()

Double casacore::VanVleck::r | ( | const Double | rho | ) |

static

Given a rho return the corresponding corrected r Returns 0.0 if no quantization has been set yet.

## rinc()

Double casacore::VanVleck::rinc | ( | Double & | rhoi,
|  | Double & | rhof )

static private

For a given rhoi, rhof, this produces a high-accuracy numerical approximation to the integral of drbydrho over the range rhoi to rhof.

It calls the standard QUADPACK adaptive Gaussian quadrature procedure, dqags, to do the numerical integration.

## setEquiSpaced()

Bool casacore::VanVleck::setEquiSpaced | ( | Double | xlev,
|  | Double | ylev,
|  | Double | xmean,
|  | Double | ymean,
|  | Int | n )

static

Set the x and y quantization levels for the case of equi-spaced levels with a possible non-zero offset.

The total number of levels is given by n, which must be 3 or 9. If n is not 3 or 9, False will be returned and no quantization will have been set. For the 3- and 9- level cases a bivarate normal integral calculation will be used. That is much faster than the more general numerical integration used by setQuantization.

## setQuantization()

void casacore::VanVleck::setQuantization | ( | const Matrix< Double > & | qx,
|  | const Matrix< Double > & | qy )

static

Set the x and y quantization functions.

Each matrix should have dimensions (2,n) where n is the number of levels. The first row (0,...) is the (n-1) threshold levels and the second row is the n quantizations based on those thresholds. The thresholds may include a DC offset. The (0,(n-1)) element is never used and need not be set.

## size()

void casacore::VanVleck::size | ( | uInt | npts | ) |

static

Set the interpolation table size.

Should be an odd number. The default size is 65.

## thresh()

Double casacore::VanVleck::thresh | ( | Int | n,
|  | Double | zerolag )

inline static

Given a measured zero-lag autocorrelation and number of levels (n>=3) return the first positive quantizer input threshold level.

This can be used to set the up the matrix arguments used in setQuantization.

Definition at line 137 of file VanVleck.h.

References threshN3(), and threshNgt3().

## threshN3()

Double casacore::VanVleck::threshN3 | ( | Double | zerolag | ) |

inline static private

compute first threshhold for a given zerolag for n==3

Definition at line 212 of file VanVleck.h.

References invErfc(), and casacore::sqrt().

Referenced by thresh().

## threshNgt3()

Double casacore::VanVleck::threshNgt3 | ( | Int | n,
|  | Double | zerolag )

static private

compute first threshhold for a given zerolag for n>3

Referenced by thresh().

## Member Data Documentation

## itsEquiSpaced

Bool casacore::VanVleck::itsEquiSpaced

static private

Definition at line 169 of file VanVleck.h.

## itsInterp

Interpolate1D<Double, Double>* casacore::VanVleck::itsInterp

static private

The interpolator.

Definition at line 174 of file VanVleck.h.

## itsNx

uInt casacore::VanVleck::itsNx

static private

Definition at line 167 of file VanVleck.h.

## itsNy

uInt casacore::VanVleck::itsNy

static private

Definition at line 167 of file VanVleck.h.

## itsQx0

Vector<Double> casacore::VanVleck::itsQx0

static private

the quantization functions

Definition at line 177 of file VanVleck.h.

## itsQx0Qx0

Vector<Double> casacore::VanVleck::itsQx0Qx0

static private

Useful combinations of the above - to speed up drbydrho these are -1/2*(Qx0*Qx0) and -1/2*(Qy0*Qy0) These are only used for i up to (itsQx0.nelements() and for j up to (itsQy0.nelements()).

Definition at line 183 of file VanVleck.h.

## itsQx0Qy0

Matrix<Double> casacore::VanVleck::itsQx0Qy0

static private

This is Qx0[i]*Qy0[j].

Definition at line 185 of file VanVleck.h.

## itsQx1

Vector<Double> casacore::VanVleck::itsQx1

static private

Definition at line 177 of file VanVleck.h.

## itsQx1Qy1diffs

Matrix<Double> casacore::VanVleck::itsQx1Qy1diffs

static private

This is (Qx1[i+1]-Qx1[i])*(Qy1[j+1]*Qy1[j]).

Definition at line 187 of file VanVleck.h.

## itsQy0

Vector<Double> casacore::VanVleck::itsQy0

static private

Definition at line 177 of file VanVleck.h.

## itsQy0Qy0

Vector<Double> casacore::VanVleck::itsQy0Qy0

static private

Definition at line 183 of file VanVleck.h.

## itsQy1

Vector<Double> casacore::VanVleck::itsQy1

static private

Definition at line 177 of file VanVleck.h.

## itsSize

uInt casacore::VanVleck::itsSize

static private

the number of points to use in setting up the interpolator

Definition at line 167 of file VanVleck.h.

## itsXlev

Double casacore::VanVleck::itsXlev

static private

Definition at line 171 of file VanVleck.h.

## itsXmean

Double casacore::VanVleck::itsXmean

static private

Definition at line 171 of file VanVleck.h.

## itsYlev

Double casacore::VanVleck::itsYlev

static private

Definition at line 171 of file VanVleck.h.

## itsYmean

Double casacore::VanVleck::itsYmean

static private

Definition at line 171 of file VanVleck.h.

## theirMutex

std::mutex casacore::VanVleck::theirMutex

static private

The mutex to make the functions thread-safe.

Definition at line 189 of file VanVleck.h.

The documentation for this class was generated from the following file:

- scimath/Mathematics/VanVleck.h